local E, L, V, P, G = unpack(ElvUI);
local M = E:GetModule('MaUI');

--Cache global variables
--Lua functions
local _G = _G
local unpack = unpack
local format = format
--WoW API / Variables
local CreateFrame = CreateFrame
local IsAddOnLoaded = IsAddOnLoaded
local GetScreenWidth = GetScreenWidth
local SetCVar = SetCVar
local PlaySoundFile = PlaySoundFile
local ReloadUI = ReloadUI
local UIFrameFadeOut = UIFrameFadeOut
local ChatFrame_AddMessageGroup = ChatFrame_AddMessageGroup
local ChatFrame_RemoveAllMessageGroups = ChatFrame_RemoveAllMessageGroups
local ChatFrame_AddChannel = ChatFrame_AddChannel
local ChatFrame_RemoveChannel = ChatFrame_RemoveChannel
local ChangeChatColor = ChangeChatColor
local ToggleChatColorNamesByClassGroup = ToggleChatColorNamesByClassGroup
local FCF_ResetChatWindows = FCF_ResetChatWindows
local FCF_SetLocked = FCF_SetLocked
local FCF_DockFrame, FCF_UnDockFrame = FCF_DockFrame, FCF_UnDockFrame
local FCF_OpenNewWindow = FCF_OpenNewWindow
local FCF_SavePositionAndDimensions = FCF_SavePositionAndDimensions
local FCF_GetChatWindowInfo = FCF_GetChatWindowInfo
local FCF_SetWindowName = FCF_SetWindowName
local FCF_StopDragging = FCF_StopDragging
local FCF_SetChatWindowFontSize = FCF_SetChatWindowFontSize
local CLASS, CONTINUE, PREVIOUS = CLASS, CONTINUE, PREVIOUS
local NUM_CHAT_WINDOWS = NUM_CHAT_WINDOWS
local LOOT, GENERAL, TRADE = LOOT, GENERAL, TRADE
local GUILD_EVENT_LOG = GUILD_EVENT_LOG
local RAID_CLASS_COLORS = RAID_CLASS_COLORS
local CUSTOM_CLASS_COLORS = CUSTOM_CLASS_COLORS

local CURRENT_PAGE = 0
local MAX_PAGE = 5

local function MaUISetupProfil()
	E.db["databars"]["artifact"]["font"] = "Expressway"
	E.db["databars"]["artifact"]["height"] = 5
	E.db["databars"]["artifact"]["hideInCombat"] = true
	E.db["databars"]["artifact"]["orientation"] = "HORIZONTAL"
	E.db["databars"]["artifact"]["width"] = 176
	E.db["databars"]["reputation"]["font"] = "Expressway"
	E.db["databars"]["reputation"]["orientation"] = "HORIZONTAL"
	E.db["databars"]["reputation"]["height"] = 5
	E.db["databars"]["reputation"]["hideInCombat"] = true
	E.db["databars"]["reputation"]["enable"] = true
	E.db["databars"]["reputation"]["width"] = 176
	E.db["databars"]["experience"]["font"] = "Expressway"
	E.db["databars"]["experience"]["orientation"] = "HORIZONTAL"
	E.db["databars"]["experience"]["hideInCombat"] = true
	E.db["databars"]["experience"]["height"] = 5
	E.db["databars"]["experience"]["width"] = 176
	E.db["databars"]["honor"]["font"] = "Expressway"
	E.db["databars"]["honor"]["orientation"] = "HORIZONTAL"
	E.db["databars"]["honor"]["height"] = 5
	E.db["databars"]["honor"]["hideInCombat"] = true
	E.db["databars"]["honor"]["textSize"] = 17
	E.db["databars"]["honor"]["width"] = 176
	E.db["general"]["totems"]["enable"] = false
	E.db["general"]["vendorGrays"] = true
	E.db["general"]["afk"] = false
	E.db["general"]["autoRepair"] = "PLAYER"
	E.db["general"]["minimap"]["locationText"] = "HIDE"
	E.db["general"]["valuecolor"]["b"] = 0.73
	E.db["general"]["valuecolor"]["g"] = 0.55
	E.db["general"]["valuecolor"]["r"] = 0.96
	E.db["general"]["font"] = "Expressway"
	E.db["general"]["bottomPanel"] = false
	E.db["general"]["objectiveFrameHeight"] = 700
	E.db["general"]["talkingHeadFrameScale"] = 0.7
	E.db["general"]["autoRoll"] = true
	E.db["general"]["bordercolor"]["b"] = 0.14117647058823
	E.db["general"]["bordercolor"]["g"] = 0.14117647058823
	E.db["general"]["bordercolor"]["r"] = 0.14117647058823
	E.db["bags"]["countFontSize"] = 12
	E.db["bags"]["itemLevelFont"] = "Expressway"
	E.db["bags"]["bagSize"] = 32
	E.db["bags"]["itemLevelFontSize"] = 12
	E.db["bags"]["junkIcon"] = true
	E.db["bags"]["countFont"] = "Expressway"
	E.db["bags"]["clearSearchOnClose"] = true
	E.db["bags"]["countFontOutline"] = "OUTLINE"
	E.db["bags"]["bankSize"] = 32
	E.db["bags"]["currencyFormat"] = "ICON"
	E.db["bags"]["bankWidth"] = 412
	E.db["bags"]["moneyFormat"] = "BLIZZARD"
	E.db["bags"]["itemLevelFontOutline"] = "OUTLINE"
	E.db["bags"]["bagWidth"] = 412
	E.db["auras"]["font"] = "Expressway"
	E.db["auras"]["fontOutline"] = "OUTLINE"
	E.db["auras"]["fontSize"] = 12
	E.db["locplus"]["ttreczones"] = false
	E.db["locplus"]["ttrecinst"] = false
	E.db["locplus"]["ht"] = true
	E.db["locplus"]["dig"] = false
	E.db["locplus"]["fish"] = false
	E.db["locplus"]["displayOther"] = "NONE"
	E.db["locplus"]["prof"] = false
	E.db["locplus"]["petlevel"] = false
	E.db["locplus"]["ttst"] = false
	E.db["thinBorderColorSet"] = true
	E.db["movers"]["ElvUF_TargetMover"] = "BOTTOM,ElvUIParent,BOTTOM,278,118"
	E.db["movers"]["ElvUF_Raid40Mover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,4,156"
	E.db["movers"]["ElvAB_2"] = "BOTTOM,ElvUIParent,BOTTOM,0,38"
	E.db["movers"]["ElvUF_PlayerCastbarMover"] = "BOTTOM,ElvUIParent,BOTTOM,0,74"
	E.db["movers"]["ElvAB_1"] = "BOTTOM,ElvUIParent,BOTTOM,0,4"
	E.db["movers"]["LeftChatMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,4,4"
	E.db["movers"]["AlertFrameMover"] = "TOP,ElvUIParent,TOP,0,-20"
	E.db["movers"]["ElvUF_PartyMover"] = "TOPLEFT,ElvUIParent,BOTTOMLEFT,4,651"
	E.db["movers"]["TalkingHeadFrameMover"] = "BOTTOM,ElvUIParent,BOTTOM,0,305"
	E.db["movers"]["LocationMover"] = "TOP,ElvUIParent,TOP,0,-4"
	E.db["movers"]["ElvUF_RaidMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,4,156"
	E.db["movers"]["BossButton"] = "BOTTOM,ElvUIParent,BOTTOM,-100,150"
	E.db["movers"]["LootFrameMover"] = "TOPLEFT,ElvUIParent,TOPLEFT,4,-70"
	E.db["movers"]["ZoneAbility"] = "BOTTOM,ElvUIParent,BOTTOM,100,150"
	E.db["movers"]["ElvUF_PlayerMover"] = "BOTTOM,ElvUIParent,BOTTOM,-278,118"
	E.db["movers"]["ArtifactBarMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-4,-215"
	E.db["movers"]["ObjectiveFrameMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-107,-240"
	E.db["movers"]["ElvUF_RaidpetMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,4,574"
	E.db["movers"]["ShiftAB"] = "TOPLEFT,ElvUIParent,BOTTOMLEFT,4,1051"
	E.db["movers"]["SquareMinimapButtonBarMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-4,-221"
	E.db["movers"]["HonorBarMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-4,-209"
	E.db["movers"]["ElvUF_TargetCastbarMover"] = "BOTTOM,ElvUIParent,BOTTOM,0,90"
	E.db["movers"]["TotemBarMover"] = "BOTTOMLEFT,ElvUIParent,BOTTOMLEFT,417,4"
	E.db["movers"]["ClassBarMover"] = "BOTTOM,ElvUIParent,BOTTOM,-278,107"
	E.db["movers"]["ReputationBarMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-4,-203"
	E.db["movers"]["ElvUF_PetMover"] = "BOTTOM,ElvUIParent,BOTTOM,0,180"
	E.db["movers"]["ElvAB_5"] = "BOTTOM,ElvUIParent,BOTTOM,-312,4"
	E.db["movers"]["RightChatMover"] = "BOTTOMRIGHT,ElvUIParent,BOTTOMRIGHT,-4,4"
	E.db["movers"]["ExperienceBarMover"] = "TOPRIGHT,ElvUIParent,TOPRIGHT,-4,-209"
	E.db["movers"]["ElvAB_3"] = "BOTTOM,ElvUIParent,BOTTOM,312,4"
	E.db["movers"]["ElvUF_TargetTargetMover"] = "BOTTOM,ElvUIParent,BOTTOM,0,133"
	E.db["gridSize"] = 128
	E.db["tooltip"]["font"] = "Expressway"
	E.db["tooltip"]["healthBar"]["height"] = 5
	E.db["tooltip"]["healthBar"]["font"] = "Expressway"
	E.db["tooltip"]["healthBar"]["fontSize"] = 12
	E.db["tooltip"]["itemCount"] = "BOTH"
	E.db["tooltip"]["fontSize"] = 12
	E.db["unitframe"]["statusbar"] = "MaUI Fer 1"
	E.db["unitframe"]["colors"]["auraBarBuff"]["b"] = 0.73
	E.db["unitframe"]["colors"]["auraBarBuff"]["g"] = 0.55
	E.db["unitframe"]["colors"]["auraBarBuff"]["r"] = 0.96
	E.db["unitframe"]["colors"]["healthclass"] = true
	E.db["unitframe"]["colors"]["customhealthbackdrop"] = true
	E.db["unitframe"]["colors"]["health_backdrop"]["b"] = 0.10196078431373
	E.db["unitframe"]["colors"]["health_backdrop"]["g"] = 0.10196078431373
	E.db["unitframe"]["colors"]["health_backdrop"]["r"] = 0.10196078431373
	E.db["unitframe"]["colors"]["castClassColor"] = true
	E.db["unitframe"]["colors"]["castColor"]["b"] = 0
	E.db["unitframe"]["colors"]["castColor"]["g"] = 0.8156862745098
	E.db["unitframe"]["colors"]["castColor"]["r"] = 1
	E.db["unitframe"]["fontOutline"] = "NONE"
	E.db["unitframe"]["smoothbars"] = true
	E.db["unitframe"]["font"] = "Expressway"
	E.db["unitframe"]["fontSize"] = 12
	E.db["unitframe"]["units"]["boss"]["debuffs"]["numrows"] = 1
	E.db["unitframe"]["units"]["boss"]["debuffs"]["sizeOverride"] = 20
	E.db["unitframe"]["units"]["boss"]["debuffs"]["yOffset"] = 0
	E.db["unitframe"]["units"]["boss"]["debuffs"]["attachTo"] = "BUFFS"
	E.db["unitframe"]["units"]["boss"]["debuffs"]["sortDirection"] = "ASCENDING"
	E.db["unitframe"]["units"]["boss"]["debuffs"]["xOffset"] = -3
	E.db["unitframe"]["units"]["boss"]["threatStyle"] = "GLOW"
	E.db["unitframe"]["units"]["boss"]["castbar"]["height"] = 10
	E.db["unitframe"]["units"]["boss"]["castbar"]["width"] = 184
	E.db["unitframe"]["units"]["boss"]["customTexts"] = {
	["mLeben"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "LEFT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 15,
					["text_format"] = "[health:current-percent]",
					["size"] = 10,
					},
	["mName"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "RIGHT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 17,
					["text_format"] = " [mRole] [namecolor][name:short]|cffFFFFFF | [level]",
					["size"] = 14,
					},
					}
	E.db["unitframe"]["units"]["boss"]["portrait"]["camDistanceScale"] = 2
	E.db["unitframe"]["units"]["boss"]["portrait"]["width"] = 45
	E.db["unitframe"]["units"]["boss"]["width"] = 184
	E.db["unitframe"]["units"]["boss"]["infoPanel"]["height"] = 17
	E.db["unitframe"]["units"]["boss"]["power"]["text_format"] = ""
	E.db["unitframe"]["units"]["boss"]["health"]["text_format"] = ""
	E.db["unitframe"]["units"]["boss"]["spacing"] = 30
	E.db["unitframe"]["units"]["boss"]["height"] = 20
	E.db["unitframe"]["units"]["boss"]["buffs"]["sizeOverride"] = 20
	E.db["unitframe"]["units"]["boss"]["buffs"]["yOffset"] = 0
	E.db["unitframe"]["units"]["boss"]["buffs"]["sortDirection"] = "ASCENDING"
	E.db["unitframe"]["units"]["boss"]["buffs"]["xOffset"] = -1
	E.db["unitframe"]["units"]["boss"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["boss"]["raidicon"]["attachTo"] = "RIGHT"
	E.db["unitframe"]["units"]["boss"]["raidicon"]["xOffset"] = -19
	E.db["unitframe"]["units"]["boss"]["raidicon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["tank"]["targetsGroup"]["height"] = 20
	E.db["unitframe"]["units"]["tank"]["targetsGroup"]["width"] = 80
	E.db["unitframe"]["units"]["tank"]["height"] = 20
	E.db["unitframe"]["units"]["tank"]["width"] = 80
	E.db["unitframe"]["units"]["targettarget"]["debuffs"]["anchorPoint"] = "BOTTOMLEFT"
	E.db["unitframe"]["units"]["targettarget"]["debuffs"]["yOffset"] = -1
	E.db["unitframe"]["units"]["targettarget"]["threatStyle"] = "GLOW"
	E.db["unitframe"]["units"]["targettarget"]["customTexts"] = {
	["mName"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "CENTER",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 16,
					["text_format"] = "[namecolor][name:short]",
					["size"] = 18,
					},
					}
	E.db["unitframe"]["units"]["targettarget"]["width"] = 100
	E.db["unitframe"]["units"]["targettarget"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["targettarget"]["height"] = 20
	E.db["unitframe"]["units"]["targettarget"]["raidicon"]["attachTo"] = "CENTER"
	E.db["unitframe"]["units"]["targettarget"]["raidicon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raid"]["debuffs"]["xOffset"] = 1
	E.db["unitframe"]["units"]["raid"]["debuffs"]["sizeOverride"] = 20
	E.db["unitframe"]["units"]["raid"]["debuffs"]["perrow"] = 5
	E.db["unitframe"]["units"]["raid"]["rdebuffs"]["font"] = "Expressway"
	E.db["unitframe"]["units"]["raid"]["rdebuffs"]["size"] = 18
	E.db["unitframe"]["units"]["raid"]["rdebuffs"]["yOffset"] = 1
	E.db["unitframe"]["units"]["raid"]["growthDirection"] = "UP_RIGHT"
	E.db["unitframe"]["units"]["raid"]["roleIcon"]["xOffset"] = 0
	E.db["unitframe"]["units"]["raid"]["roleIcon"]["position"] = "RIGHT"
	E.db["unitframe"]["units"]["raid"]["roleIcon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raid"]["raidWideSorting"] = false
	E.db["unitframe"]["units"]["raid"]["power"]["position"] = "RIGHT"
	E.db["unitframe"]["units"]["raid"]["power"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raid"]["customTexts"] = {
	["mName"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "LEFT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 14,
					["text_format"] = "[namecolor][name:short]",
					["size"] = 12,
					},
	["mLeben"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "RIGHT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 13,
					["text_format"] = "[mHealth]",
					["size"] = 8,
					},
					}
	E.db["unitframe"]["units"]["raid"]["buffs"]["perrow"] = 4
	E.db["unitframe"]["units"]["raid"]["orientation"] = "LEFT"
	E.db["unitframe"]["units"]["raid"]["infoPanel"]["height"] = 15
	E.db["unitframe"]["units"]["raid"]["health"]["xOffset"] = 2
	E.db["unitframe"]["units"]["raid"]["health"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raid"]["health"]["text_format"] = ""
	E.db["unitframe"]["units"]["raid"]["health"]["position"] = "LEFT"
	E.db["unitframe"]["units"]["raid"]["name"]["text_format"] = "[mouseover][mGroup]"
	E.db["unitframe"]["units"]["raid"]["sortDir"] = "DESC"
	E.db["unitframe"]["units"]["raid"]["height"] = 20
	E.db["unitframe"]["units"]["raid"]["verticalSpacing"] = 15
	E.db["unitframe"]["units"]["raid"]["groupBy"] = "ROLE"
	E.db["unitframe"]["units"]["raid"]["raidicon"]["attachTo"] = "LEFT"
	E.db["unitframe"]["units"]["raid"]["raidicon"]["xOffset"] = 2
	E.db["unitframe"]["units"]["raid"]["raidicon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["pet"]["debuffs"]["anchorPoint"] = "BOTTOMLEFT"
	E.db["unitframe"]["units"]["pet"]["debuffs"]["yOffset"] = -1
	E.db["unitframe"]["units"]["pet"]["portrait"]["camDistanceScale"] = 2
	E.db["unitframe"]["units"]["pet"]["customTexts"] = {
	["mName"]= {
				["attachTextTo"] = "Health",
				["font"] = "Expressway",
				["justifyH"] = "CENTER",
				["fontOutline"] = "NONE",
				["xOffset"] = 0,
				["size"] = 18,
				["text_format"] = "[namecolor][name:short]",
				["yOffset"] = 16,
				},
				}
	E.db["unitframe"]["units"]["pet"]["width"] = 100
	E.db["unitframe"]["units"]["pet"]["infoPanel"]["height"] = 14
	E.db["unitframe"]["units"]["pet"]["height"] = 20
	E.db["unitframe"]["units"]["pet"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["pet"]["castbar"]["enable"] = false
	E.db["unitframe"]["units"]["pet"]["castbar"]["width"] = 100
	E.db["unitframe"]["units"]["assist"]["targetsGroup"]["height"] = 20
	E.db["unitframe"]["units"]["assist"]["targetsGroup"]["width"] = 80
	E.db["unitframe"]["units"]["assist"]["height"] = 20
	E.db["unitframe"]["units"]["assist"]["width"] = 80
	E.db["unitframe"]["units"]["raidpet"]["debuffs"]["xOffset"] = 1
	E.db["unitframe"]["units"]["raidpet"]["debuffs"]["sizeOverride"] = 20
	E.db["unitframe"]["units"]["raidpet"]["debuffs"]["perrow"] = 5
	E.db["unitframe"]["units"]["raidpet"]["portrait"]["camDistanceScale"] = 2
	E.db["unitframe"]["units"]["raidpet"]["rdebuffs"]["size"] = 18
	E.db["unitframe"]["units"]["raidpet"]["rdebuffs"]["yOffset"] = 1
	E.db["unitframe"]["units"]["raidpet"]["numGroups"] = 5
	E.db["unitframe"]["units"]["raidpet"]["growthDirection"] = "UP_RIGHT"
	E.db["unitframe"]["units"]["raidpet"]["customTexts"] = {
	["mLeben"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "RIGHT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 13,
					["text_format"] = "[afk]",
					["size"] = 8,
					},
	["mName"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "LEFT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 14,
					["text_format"] = "[namecolor][name:short] [mRole]",
					["size"] = 12,
					},
					}
	E.db["unitframe"]["units"]["raidpet"]["healPrediction"] = false
	E.db["unitframe"]["units"]["raidpet"]["groupBy"] = "GROUP"
	E.db["unitframe"]["units"]["raidpet"]["sortDir"] = "DESC"
	E.db["unitframe"]["units"]["raidpet"]["verticalSpacing"] = 15
	E.db["unitframe"]["units"]["raidpet"]["name"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raidpet"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["raidpet"]["name"]["position"] = "CENTER"
	E.db["unitframe"]["units"]["raidpet"]["height"] = 20
	E.db["unitframe"]["units"]["raidpet"]["orientation"] = "LEFT"
	E.db["unitframe"]["units"]["raidpet"]["buffs"]["perrow"] = 4
	E.db["unitframe"]["units"]["raidpet"]["health"]["frequentUpdates"] = false
	E.db["unitframe"]["units"]["raidpet"]["health"]["position"] = "LEFT"
	E.db["unitframe"]["units"]["raidpet"]["health"]["xOffset"] = 2
	E.db["unitframe"]["units"]["raidpet"]["health"]["text_format"] = ""
	E.db["unitframe"]["units"]["raidpet"]["health"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raidpet"]["raidicon"]["attachTo"] = "LEFT"
	E.db["unitframe"]["units"]["raidpet"]["raidicon"]["xOffset"] = 2
	E.db["unitframe"]["units"]["raidpet"]["raidicon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["player"]["debuffs"]["attachTo"] = "HEALTH"
	E.db["unitframe"]["units"]["player"]["debuffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["player"]["debuffs"]["perrow"] = 9
	E.db["unitframe"]["units"]["player"]["debuffs"]["yOffset"] = 24
	E.db["unitframe"]["units"]["player"]["classbar"]["detachFromFrame"] = true
	E.db["unitframe"]["units"]["player"]["classbar"]["autoHide"] = true
	E.db["unitframe"]["units"]["player"]["classbar"]["detachedWidth"] = 270
	E.db["unitframe"]["units"]["player"]["classbar"]["fill"] = "spaced"
	E.db["unitframe"]["units"]["player"]["aurabar"]["enable"] = false
	E.db["unitframe"]["units"]["player"]["restIcon"] = false
	E.db["unitframe"]["units"]["player"]["castbar"]["height"] = 14
	E.db["unitframe"]["units"]["player"]["customTexts"] = {
	["mPvP"] = {
				["attachTextTo"] = "Health",
				["font"] = "Expressway",
				["justifyH"] = "CENTER",
				["fontOutline"] = "NONE",
				["xOffset"] = 0,
				["yOffset"] = 0,
				["text_format"] = "|cFFB04F4F[pvptimer][mouseover]|r",
				["size"] = 16,
				},													
	["mLeben"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "RIGHT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["size"] = 14,
					["text_format"] = "[afk] [health:current-percent]",
					["yOffset"] = 22,
					},
	["mKraft"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "RIGHT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["size"] = 10,
					["text_format"] = "[powercolor][power:percent]",
					["yOffset"] = 33,
					},
	["mName"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "LEFT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["size"] = 20,
					["text_format"] = "[mLevel] | [namecolor][name:medium]",
					["yOffset"] = 24,
					},
					}
	E.db["unitframe"]["units"]["player"]["health"]["text_format"] = ""
	E.db["unitframe"]["units"]["player"]["combatfade"] = true
	E.db["unitframe"]["units"]["player"]["name"]["xOffset"] = 2
	E.db["unitframe"]["units"]["player"]["name"]["text_format"] = "[mouseover][mGroup]"
	E.db["unitframe"]["units"]["player"]["name"]["position"] = "LEFT"
	E.db["unitframe"]["units"]["player"]["power"]["detachedWidth"] = 270
	E.db["unitframe"]["units"]["player"]["power"]["xOffset"] = 0
	E.db["unitframe"]["units"]["player"]["power"]["text_format"] = ""
	E.db["unitframe"]["units"]["player"]["power"]["height"] = 7
	E.db["unitframe"]["units"]["player"]["height"] = 25
	E.db["unitframe"]["units"]["player"]["buffs"]["enable"] = false
	E.db["unitframe"]["units"]["player"]["buffs"]["attachTo"] = "FRAME"
	E.db["unitframe"]["units"]["player"]["buffs"]["sizeOverride"] = 20
	E.db["unitframe"]["units"]["player"]["buffs"]["noDuration"] = false
	E.db["unitframe"]["units"]["player"]["raidicon"]["attachTo"] = "RIGHT"
	E.db["unitframe"]["units"]["player"]["raidicon"]["xOffset"] = -2
	E.db["unitframe"]["units"]["player"]["raidicon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["player"]["pvp"]["text_format"] = ""
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["xOffset"] = 1
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["sizeOverride"] = 20
	E.db["unitframe"]["units"]["raid40"]["debuffs"]["perrow"] = 5
	E.db["unitframe"]["units"]["raid40"]["portrait"]["camDistanceScale"] = 2
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["font"] = "Expressway"
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["size"] = 18
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["enable"] = true
	E.db["unitframe"]["units"]["raid40"]["rdebuffs"]["yOffset"] = 1
	E.db["unitframe"]["units"]["raid40"]["growthDirection"] = "RIGHT_UP"
	E.db["unitframe"]["units"]["raid40"]["roleIcon"]["enable"] = true
	E.db["unitframe"]["units"]["raid40"]["roleIcon"]["position"] = "RIGHT"
	E.db["unitframe"]["units"]["raid40"]["roleIcon"]["xOffset"] = 0
	E.db["unitframe"]["units"]["raid40"]["roleIcon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raid40"]["raidWideSorting"] = false
	E.db["unitframe"]["units"]["raid40"]["power"]["enable"] = true
	E.db["unitframe"]["units"]["raid40"]["power"]["position"] = "RIGHT"
	E.db["unitframe"]["units"]["raid40"]["power"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raid40"]["customTexts"] = {
	["mLeben"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "RIGHT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 13,
					["text_format"] = "[mHealth]",
					["size"] = 8,
					},
	["mName"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "LEFT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 14,
					["text_format"] = "[namecolor][name:short]",
					["size"] = 12,
					},
					}
	E.db["unitframe"]["units"]["raid40"]["buffs"]["perrow"] = 4
	E.db["unitframe"]["units"]["raid40"]["orientation"] = "LEFT"
	E.db["unitframe"]["units"]["raid40"]["infoPanel"]["height"] = 15
	E.db["unitframe"]["units"]["raid40"]["health"]["xOffset"] = 2
	E.db["unitframe"]["units"]["raid40"]["health"]["yOffset"] = 0
	E.db["unitframe"]["units"]["raid40"]["health"]["text_format"] = ""
	E.db["unitframe"]["units"]["raid40"]["health"]["position"] = "LEFT"
	E.db["unitframe"]["units"]["raid40"]["name"]["text_format"] = "[mouseover][mGroup]"
	E.db["unitframe"]["units"]["raid40"]["sortDir"] = "DESC"
	E.db["unitframe"]["units"]["raid40"]["height"] = 20
	E.db["unitframe"]["units"]["raid40"]["verticalSpacing"] = 15
	E.db["unitframe"]["units"]["raid40"]["groupBy"] = "ROLE"
	E.db["unitframe"]["units"]["raid40"]["raidicon"]["attachTo"] = "LEFT"
	E.db["unitframe"]["units"]["raid40"]["raidicon"]["xOffset"] = 2
	E.db["unitframe"]["units"]["raid40"]["raidicon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["focus"]["debuffs"]["anchorPoint"] = "BOTTOMLEFT"
	E.db["unitframe"]["units"]["focus"]["debuffs"]["yOffset"] = -12
	E.db["unitframe"]["units"]["focus"]["castbar"]["height"] = 10
	E.db["unitframe"]["units"]["focus"]["castbar"]["icon"] = false
	E.db["unitframe"]["units"]["focus"]["castbar"]["width"] = 130
	E.db["unitframe"]["units"]["focus"]["customTexts"] = {
	["mName"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "CENTER",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 16,
					["text_format"] = "[namecolor][name:medium]",
					["size"] = 18,
					},
					}
	E.db["unitframe"]["units"]["focus"]["width"] = 130
	E.db["unitframe"]["units"]["focus"]["raidicon"]["attachTo"] = "CENTER"
	E.db["unitframe"]["units"]["focus"]["raidicon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["focus"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["focus"]["height"] = 20
	E.db["unitframe"]["units"]["target"]["debuffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["target"]["debuffs"]["yOffset"] = 51
	E.db["unitframe"]["units"]["target"]["debuffs"]["attachTo"] = "HEALTH"
	E.db["unitframe"]["units"]["target"]["debuffs"]["perrow"] = 9
	E.db["unitframe"]["units"]["target"]["power"]["xOffset"] = 0
	E.db["unitframe"]["units"]["target"]["power"]["detachedWidth"] = 270
	E.db["unitframe"]["units"]["target"]["power"]["hideonnpc"] = false
	E.db["unitframe"]["units"]["target"]["power"]["text_format"] = ""
	E.db["unitframe"]["units"]["target"]["power"]["height"] = 7
	E.db["unitframe"]["units"]["target"]["customTexts"] = {
	["mLeben"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "LEFT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 22,
					["text_format"] = "[mClass][health:current-percent] [afk]",
					["size"] = 14,
					},
	["mKraft"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "LEFT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 33,
					["text_format"] = "[powercolor][power:percent]",
					["size"] = 10,
					},
	["mName"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "RIGHT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 24,
					["text_format"] = "[namecolor][name:short]|cffFFFFFF | [level]",
					["size"] = 20,
					},
					}
	E.db["unitframe"]["units"]["target"]["raidicon"]["attachTo"] = "LEFT"
	E.db["unitframe"]["units"]["target"]["raidicon"]["xOffset"] = 2
	E.db["unitframe"]["units"]["target"]["raidicon"]["yOffset"] = 0
	E.db["unitframe"]["units"]["target"]["health"]["xOffset"] = 2
	E.db["unitframe"]["units"]["target"]["health"]["text_format"] = ""
	E.db["unitframe"]["units"]["target"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["target"]["smartAuraPosition"] = "DEBUFFS_ON_BUFFS"
	E.db["unitframe"]["units"]["target"]["height"] = 25
	E.db["unitframe"]["units"]["target"]["buffs"]["sizeOverride"] = 30
	E.db["unitframe"]["units"]["target"]["buffs"]["yOffset"] = 24
	E.db["unitframe"]["units"]["target"]["buffs"]["attachTo"] = "HEALTH"
	E.db["unitframe"]["units"]["target"]["buffs"]["perrow"] = 9
	E.db["unitframe"]["units"]["target"]["smartAuraDisplay"] = "DISABLED"
	E.db["unitframe"]["units"]["target"]["aurabar"]["maxDuration"] = 120
	E.db["unitframe"]["units"]["target"]["aurabar"]["enable"] = false
	E.db["unitframe"]["units"]["arena"]["debuffs"]["sizeOverride"] = 20
	E.db["unitframe"]["units"]["arena"]["debuffs"]["yOffset"] = 0
	E.db["unitframe"]["units"]["arena"]["debuffs"]["attachTo"] = "BUFFS"
	E.db["unitframe"]["units"]["arena"]["debuffs"]["sortDirection"] = "ASCENDING"
	E.db["unitframe"]["units"]["arena"]["debuffs"]["xOffset"] = -3
	E.db["unitframe"]["units"]["arena"]["power"]["text_format"] = ""
	E.db["unitframe"]["units"]["arena"]["customTexts"] = {
	["mLeben"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "LEFT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 15,
					["text_format"] = "[health:current-percent] [afk]",
					["size"] = 10,
					},
	["mName"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "RIGHT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 17,
					["text_format"] = " [mRole] [namecolor][name:short]|cffFFFFFF | [level]",
					["size"] = 14,
					},
					}
	E.db["unitframe"]["units"]["arena"]["width"] = 184
	E.db["unitframe"]["units"]["arena"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["arena"]["spacing"] = 30
	E.db["unitframe"]["units"]["arena"]["height"] = 20
	E.db["unitframe"]["units"]["arena"]["buffs"]["sizeOverride"] = 20
	E.db["unitframe"]["units"]["arena"]["buffs"]["yOffset"] = 0
	E.db["unitframe"]["units"]["arena"]["buffs"]["sortDirection"] = "ASCENDING"
	E.db["unitframe"]["units"]["arena"]["buffs"]["xOffset"] = -1
	E.db["unitframe"]["units"]["arena"]["health"]["text_format"] = ""
	E.db["unitframe"]["units"]["arena"]["castbar"]["height"] = 10
	E.db["unitframe"]["units"]["arena"]["castbar"]["width"] = 184
	E.db["unitframe"]["units"]["party"]["debuffs"]["xOffset"] = 1
	E.db["unitframe"]["units"]["party"]["debuffs"]["sizeOverride"] = 20
	E.db["unitframe"]["units"]["party"]["debuffs"]["perrow"] = 5
	E.db["unitframe"]["units"]["party"]["rdebuffs"]["font"] = "Expressway"
	E.db["unitframe"]["units"]["party"]["rdebuffs"]["size"] = 18
	E.db["unitframe"]["units"]["party"]["rdebuffs"]["xOffset"] = 40
	E.db["unitframe"]["units"]["party"]["rdebuffs"]["enable"] = true
	E.db["unitframe"]["units"]["party"]["rdebuffs"]["yOffset"] = 1
	E.db["unitframe"]["units"]["party"]["growthDirection"] = "DOWN_RIGHT"
	E.db["unitframe"]["units"]["party"]["groupBy"] = "ROLE"
	E.db["unitframe"]["units"]["party"]["roleIcon"]["position"] = "RIGHT"
	E.db["unitframe"]["units"]["party"]["power"]["text_format"] = ""
	E.db["unitframe"]["units"]["party"]["customTexts"] = {
	["mName"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "LEFT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 17,
					["text_format"] = "[level] | [namecolor][name:short] [mRole]",
					["size"] = 14,
					},
	["mLeben"] = {
					["attachTextTo"] = "Health",
					["font"] = "Expressway",
					["justifyH"] = "RIGHT",
					["fontOutline"] = "NONE",
					["xOffset"] = 0,
					["yOffset"] = 15,
					["text_format"] = "[mHealth]",
					["size"] = 10,
					},
					}
	E.db["unitframe"]["units"]["party"]["name"]["text_format"] = ""
	E.db["unitframe"]["units"]["party"]["health"]["text_format"] = ""
	E.db["unitframe"]["units"]["party"]["height"] = 20
	E.db["unitframe"]["units"]["party"]["verticalSpacing"] = 30
	E.db["unitframe"]["units"]["party"]["raidicon"]["attachTo"] = "LEFT"
	E.db["unitframe"]["units"]["party"]["raidicon"]["xOffset"] = 19
	E.db["unitframe"]["units"]["party"]["raidicon"]["yOffset"] = 0
	E.db["actionbar"]["bar3"]["buttons"] = 12
	E.db["actionbar"]["extraActionButton"]["scale"] = 0.6
	E.db["actionbar"]["extraActionButton"]["alpha"] = 0.75
	E.db["actionbar"]["bar2"]["enabled"] = true
	E.db["actionbar"]["bar4"]["enabled"] = false
	E.db["actionbar"]["bar5"]["buttons"] = 12
	E.db["actionbar"]["fontOutline"] = "OUTLINE"
	E.db["actionbar"]["font"] = "Expressway"
	E.db["actionbar"]["fontSize"] = 12
	E.db["actionbar"]["macrotext"] = true
	E.db["actionbar"]["barPet"]["backdrop"] = false
	E.db["actionbar"]["barPet"]["buttonsize"] = 28
	E.db["actionbar"]["backdropSpacingConverted"] = true
	E.db["nameplates"]["threat"]["beingTankedByTankColor"]["b"] = 0.53333333333333
	E.db["nameplates"]["threat"]["beingTankedByTankColor"]["g"] = 0.11764705882353
	E.db["nameplates"]["threat"]["beingTankedByTankColor"]["r"] = 1
	E.db["nameplates"]["threat"]["goodColor"]["b"] = 0.25490196078431
	E.db["nameplates"]["threat"]["goodColor"]["g"] = 0.89019607843137
	E.db["nameplates"]["threat"]["goodColor"]["r"] = 0.17254901960784
	E.db["nameplates"]["threat"]["badScale"] = 1.5
	E.db["nameplates"]["threat"]["goodTransition"]["b"] = 0.027450980392157
	E.db["nameplates"]["threat"]["goodTransition"]["g"] = 0.63137254901961
	E.db["nameplates"]["threat"]["goodTransition"]["r"] = 1
	E.db["nameplates"]["threat"]["badColor"]["b"] = 0.12549019607843
	E.db["nameplates"]["threat"]["badColor"]["g"] = 0.15686274509804
	E.db["nameplates"]["threat"]["badColor"]["r"] = 1
	E.db["nameplates"]["statusbar"] = "MaUI Fer 1"
	E.db["nameplates"]["units"]["ENEMY_NPC"]["healthbar"]["text"]["format"] = "CURRENT_PERCENT"
	E.db["nameplates"]["units"]["ENEMY_NPC"]["powerbar"]["height"] = 4
	E.db["nameplates"]["units"]["ENEMY_NPC"]["eliteIcon"]["enable"] = true
	E.db["nameplates"]["units"]["ENEMY_NPC"]["eliteIcon"]["xOffset"] = 10
	E.db["nameplates"]["clampToScreen"] = true
	E.db["nameplates"]["motionType"] = "OVERLAP"
	E.db["nameplates"]["fontOutline"] = "NONE"
	E.db["nameplates"]["font"] = "Expressway"
	E.db["nameplates"]["classbar"]["enable"] = false
	E.db["nameplates"]["fontSize"] = 12
	E.db["chat"]["useCustomTimeColor"] = false
	E.db["chat"]["keywordSound"] = "Whisper Alert"
	E.db["chat"]["tabFont"] = "Expressway"
	E.db["chat"]["keywords"] = "ElvUI, %MYNAME%"
	E.db["chat"]["tabFontSize"] = 14
	E.db["chat"]["timeStampFormat"] = "%H:%M "
	E.db["chat"]["font"] = "Expressway"
	E.db["chat"]["noAlertInCombat"] = true
	E.db["chat"]["panelHeight"] = 150
	E.db["chat"]["numScrollMessages"] = 1
	E.db["chat"]["fontSize"] = 12
	E.db["chat"]["tapFontSize"] = 12
	E.db["chat"]["panelTabTransparency"] = true
	E.db["datatexts"]["goldCoins"] = true
	E.db["datatexts"]["font"] = "Expressway"
	E.db["datatexts"]["panelTransparency"] = true
	E.db["datatexts"]["time24"] = true
	E.db["datatexts"]["panels"]["LeftMiniPanel"] = "Berufe"
	E.db["datatexts"]["panels"]["RightMiniPanel"] = "Time"
	E.db["datatexts"]["panels"]["RightChatDataPanel"]["middle"] = "Menu"
	E.db["datatexts"]["panels"]["RightCoordDtPanel"] = "Uraltes Mana"
	E.db["datatexts"]["panels"]["LeftCoordDtPanel"] = "Ordensressourcen"
	E.db["datatexts"]["panels"]["LeftChatDataPanel"]["left"] = "Guild"
	E.db["datatexts"]["panels"]["LeftChatDataPanel"]["right"] = "Friends"
	E.db["datatexts"]["currencies"]["displayedCurrency"] = "ANCIENT_MANA"

	E:UpdateAll(true)
end

local function MaUISetupPrivate()
	E.private["general"]["chatBubbleFontSize"] = 12
	E.private["general"]["chatBubbles"] = "nobackdrop"
	E.private["general"]["chatBubbleFontOutline"] = "OUTLINE"
	E.private["general"]["namefont"] = "Expressway"
	E.private["general"]["normTex"] = "MaUI Fer 1"
	E.private["general"]["chatBubbleFont"] = "Expressway"
	E.private["general"]["glossTex"] = "MaUI Fer 1"
	E.private["general"]["dmgfont"] = "Expressway"

	E:UpdateAll(true)
end

local function MaUISetupGlobal()
	DT:RegisterCustomCurrencyDT(1220)
	DT:RegisterCustomCurrencyDT(1155)
	
	E:UpdateAll(true)
end

local function InstallComplete()
	E.db.MaUI.installed = true

	ReloadUI()
end

local function ResetAll()
	InstallNextButton:Disable()
	InstallPrevButton:Disable()
	InstallOption1Button:Hide()
	InstallOption1Button:SetScript("OnClick", nil)
	InstallOption1Button:SetText("")
	InstallOption2Button:Hide()
	InstallOption2Button:SetScript('OnClick', nil)
	InstallOption2Button:SetText('')
	InstallOption3Button:Hide()
	InstallOption3Button:SetScript('OnClick', nil)
	InstallOption3Button:SetText('')
	InstallOption4Button:Hide()
	InstallOption4Button:SetScript('OnClick', nil)
	InstallOption4Button:SetText('')
	MaUIInstallFrame.SubTitle:SetText("")
	MaUIInstallFrame.Desc1:SetText("")
	MaUIInstallFrame.Desc2:SetText("")
	MaUIInstallFrame.Desc3:SetText("")
	MaUIInstallFrame:Size(550, 400)
end

local function SetPage(PageNum)
	CURRENT_PAGE = PageNum
	ResetAll()
	InstallStatus.anim.progress:SetChange(PageNum)
	InstallStatus.anim.progress:Play()
	InstallStatus.text:SetText(CURRENT_PAGE.." / "..MAX_PAGE)

	local r, g, b = E:ColorGradient(CURRENT_PAGE / MAX_PAGE, 1, 0, 0, 1, 1, 0, 0, 1, 0)
	MaUIInstallFrame.Status:SetStatusBarColor(r, g, b)
	local f = MaUIInstallFrame

	if PageNum == MAX_PAGE then
		InstallNextButton:Disable()
	else
		InstallNextButton:Enable()
	end

	if PageNum == 1 then
		InstallPrevButton:Disable()
	else
		InstallPrevButton:Enable()
	end

	if PageNum == 1 then
		f.SubTitle:SetFormattedText(L["Welcome to MaUI"])
		f.Desc1:SetText(L["This install process will help you learn some of the features in ElvUI has to offer and also prepare your user interface for usage."])
		f.Desc2:SetText(L["The in-game configuration menu can be accessed by typing the /ec command or by clicking the 'C' button on the minimap. Press the button below if you wish to skip the installation process."])
		f.Desc3:SetText(L["Please press the continue button to go onto the next step."])

		InstallOption1Button:Show()
		InstallOption1Button:SetScript("OnClick", InstallComplete)
		InstallOption1Button:SetText(L["Skip Process"])
	elseif PageNum == 2 then
		f.SubTitle:SetText(L["Profil"])
		f.Desc1:SetText(L["This part of the installation process sets up your World of Warcraft default options it is recommended you should do this step for everything to behave properly."])
		f.Desc2:SetText(L["Please click the button below to setup your Profil."])
		f.Desc3:SetText(L["Importance: |cff07D400High|r"])
		InstallOption1Button:Show()
		InstallOption1Button:SetScript("OnClick", MaUISetupProfil)
		InstallOption1Button:SetText(L["Setup Profil"])
	elseif PageNum == 3 then
		f.SubTitle:SetText(L["Private"])
		f.Desc1:SetText(L["This part of the installation process sets up your Private Profil."])
		f.Desc2:SetText(L[""])
		f.Desc3:SetText(L["Importance: |cffD3CF00Medium|r"])
		InstallOption1Button:Show()
		InstallOption1Button:SetScript("OnClick", MaUISetupPrivate)
		InstallOption1Button:SetText(L["Setup Private"])
	elseif PageNum == 4 then
		f.SubTitle:SetText(L["Global"])
		f.Desc1:SetText(L["This part of the installation process sets up your Global Profil."])
		f.Desc2:SetText(L[""])
		f.Desc3:SetText(L["Importance: |cffD3CF00Medium|r"])
		InstallOption1Button:Show()
		InstallOption1Button:SetScript("OnClick", MaUISetupGlobal)
		InstallOption1Button:SetText(L["Setup Global"])
	elseif PageNum == 5 then
		f.SubTitle:SetText(L["Installation Complete"])
		f.Desc1:SetText(L["You are now finished with the installation process. If you are in need of technical support please visit us at http://www.tukui.org."])
		f.Desc2:SetText(L["Please click the button below so you can setup variables and ReloadUI."])
		InstallOption1Button:Show()
		InstallOption1Button:SetScript("OnClick", InstallComplete)
		InstallOption1Button:SetText(L["Finished"])
		MaUIInstallFrame:Size(550, 350)
	end
end

local function NextPage()
	if CURRENT_PAGE ~= MAX_PAGE then
		CURRENT_PAGE = CURRENT_PAGE + 1
		SetPage(CURRENT_PAGE)
	end
end

local function PreviousPage()
	if CURRENT_PAGE ~= 1 then
		CURRENT_PAGE = CURRENT_PAGE - 1
		SetPage(CURRENT_PAGE)
	end
end

--Install UI
function M:SetupMaUI()
	if not InstallStepComplete then
		local imsg = CreateFrame("Frame", "InstallStepComplete", E.UIParent)
		imsg:Size(418, 72)
		imsg:Point("TOP", 0, -190)
		imsg:Hide()
		imsg:SetScript('OnShow', function(self)
			if self.message then
				PlaySoundFile([[Sound\Interface\LevelUp.wav]])
				self.text:SetText(self.message)
				UIFrameFadeOut(self, 3.5, 1, 0)
				E:Delay(4, function() self:Hide() end)
				self.message = nil
			else
				self:Hide()
			end
		end)

		imsg.firstShow = false

		imsg.bg = imsg:CreateTexture(nil, 'BACKGROUND')
		imsg.bg:SetTexture([[Interface\LevelUp\LevelUpTex]])
		imsg.bg:Point('BOTTOM')
		imsg.bg:Size(326, 103)
		imsg.bg:SetTexCoord(0.00195313, 0.63867188, 0.03710938, 0.23828125)
		imsg.bg:SetVertexColor(1, 1, 1, 0.6)

		imsg.lineTop = imsg:CreateTexture(nil, 'BACKGROUND')
		imsg.lineTop:SetDrawLayer('BACKGROUND', 2)
		imsg.lineTop:SetTexture([[Interface\LevelUp\LevelUpTex]])
		imsg.lineTop:Point("TOP")
		imsg.lineTop:Size(418, 7)
		imsg.lineTop:SetTexCoord(0.00195313, 0.81835938, 0.01953125, 0.03320313)

		imsg.lineBottom = imsg:CreateTexture(nil, 'BACKGROUND')
		imsg.lineBottom:SetDrawLayer('BACKGROUND', 2)
		imsg.lineBottom:SetTexture([[Interface\LevelUp\LevelUpTex]])
		imsg.lineBottom:Point("BOTTOM")
		imsg.lineBottom:Size(418, 7)
		imsg.lineBottom:SetTexCoord(0.00195313, 0.81835938, 0.01953125, 0.03320313)

		imsg.text = imsg:CreateFontString(nil, 'ARTWORK', 'GameFont_Gigantic')
		imsg.text:Point("BOTTOM", 0, 12)
		imsg.text:SetTextColor(1, 0.82, 0)
		imsg.text:SetJustifyH("CENTER")
	end

	--Create Frame
	if not MaUIInstallFrame then
		local f = CreateFrame("Button", "MaUIInstallFrame", E.UIParent)
		f.SetPage = SetPage
		f:Size(550, 400)
		f:SetTemplate("Transparent")
		f:Point("CENTER")
		f:SetFrameStrata('TOOLTIP')

		f.Title = f:CreateFontString(nil, 'OVERLAY')
		f.Title:FontTemplate(nil, 17, nil)
		f.Title:Point("TOP", 0, -5)
		f.Title:SetText(L["MaUI Installation"])

		f.Next = CreateFrame("Button", "InstallNextButton", f, "UIPanelButtonTemplate")
		f.Next:StripTextures()
		f.Next:SetTemplate("Default", true)
		f.Next:Size(110, 25)
		f.Next:Point("BOTTOMRIGHT", -5, 5)
		f.Next:SetText(CONTINUE)
		f.Next:Disable()
		f.Next:SetScript("OnClick", NextPage)
		E.Skins:HandleButton(f.Next, true)

		f.Prev = CreateFrame("Button", "InstallPrevButton", f, "UIPanelButtonTemplate")
		f.Prev:StripTextures()
		f.Prev:SetTemplate("Default", true)
		f.Prev:Size(110, 25)
		f.Prev:Point("BOTTOMLEFT", 5, 5)
		f.Prev:SetText(PREVIOUS)
		f.Prev:Disable()
		f.Prev:SetScript("OnClick", PreviousPage)
		E.Skins:HandleButton(f.Prev, true)

		f.Status = CreateFrame("StatusBar", "InstallStatus", f)
		f.Status:SetFrameLevel(f.Status:GetFrameLevel() + 2)
		f.Status:CreateBackdrop("Default")
		f.Status:SetStatusBarTexture(E["media"].normTex)
		E:RegisterStatusBar(f.Status)
		f.Status:SetStatusBarColor(1, 0, 0)
		f.Status:SetMinMaxValues(0, MAX_PAGE)
		f.Status:Point("TOPLEFT", f.Prev, "TOPRIGHT", 6, -2)
		f.Status:Point("BOTTOMRIGHT", f.Next, "BOTTOMLEFT", -6, 2)
		f.Status.anim = CreateAnimationGroup(f.Status)
		f.Status.anim.progress = f.Status.anim:CreateAnimation("Progress")
		f.Status.anim.progress:SetSmoothing("Out")
		f.Status.anim.progress:SetDuration(.3)

		f.Status.text = f.Status:CreateFontString(nil, 'OVERLAY')
		f.Status.text:FontTemplate()
		f.Status.text:Point("CENTER")
		f.Status.text:SetText(CURRENT_PAGE.." / "..MAX_PAGE)

		f.Option1 = CreateFrame("Button", "InstallOption1Button", f, "UIPanelButtonTemplate")
		f.Option1:StripTextures()
		f.Option1:Size(160, 30)
		f.Option1:Point("BOTTOM", 0, 45)
		f.Option1:SetText("")
		f.Option1:Hide()
		E.Skins:HandleButton(f.Option1, true)

		f.Option2 = CreateFrame("Button", "InstallOption2Button", f, "UIPanelButtonTemplate")
		f.Option2:StripTextures()
		f.Option2:Size(110, 30)
		f.Option2:Point('BOTTOMLEFT', f, 'BOTTOM', 4, 45)
		f.Option2:SetText("")
		f.Option2:Hide()
		f.Option2:SetScript('OnShow', function() f.Option1:Width(110); f.Option1:ClearAllPoints(); f.Option1:Point('BOTTOMRIGHT', f, 'BOTTOM', -4, 45) end)
		f.Option2:SetScript('OnHide', function() f.Option1:Width(160); f.Option1:ClearAllPoints(); f.Option1:Point("BOTTOM", 0, 45) end)
		E.Skins:HandleButton(f.Option2, true)

		f.Option3 = CreateFrame("Button", "InstallOption3Button", f, "UIPanelButtonTemplate")
		f.Option3:StripTextures()
		f.Option3:Size(100, 30)
		f.Option3:Point('LEFT', f.Option2, 'RIGHT', 4, 0)
		f.Option3:SetText("")
		f.Option3:Hide()
		f.Option3:SetScript('OnShow', function() f.Option1:Width(100); f.Option1:ClearAllPoints(); f.Option1:Point('RIGHT', f.Option2, 'LEFT', -4, 0); f.Option2:Width(100); f.Option2:ClearAllPoints(); f.Option2:Point('BOTTOM', f, 'BOTTOM', 0, 45)  end)
		f.Option3:SetScript('OnHide', function() f.Option1:Width(160); f.Option1:ClearAllPoints(); f.Option1:Point("BOTTOM", 0, 45); f.Option2:Width(110); f.Option2:ClearAllPoints(); f.Option2:Point('BOTTOMLEFT', f, 'BOTTOM', 4, 45) end)
		E.Skins:HandleButton(f.Option3, true)

		f.Option4 = CreateFrame("Button", "InstallOption4Button", f, "UIPanelButtonTemplate")
		f.Option4:StripTextures()
		f.Option4:Size(100, 30)
		f.Option4:Point('LEFT', f.Option3, 'RIGHT', 4, 0)
		f.Option4:SetText("")
		f.Option4:Hide()
		f.Option4:SetScript('OnShow', function()
			f.Option1:Width(100)
			f.Option2:Width(100)

			f.Option1:ClearAllPoints();
			f.Option1:Point('RIGHT', f.Option2, 'LEFT', -4, 0);
			f.Option2:ClearAllPoints();
			f.Option2:Point('BOTTOMRIGHT', f, 'BOTTOM', -4, 45)
		end)
		f.Option4:SetScript('OnHide', function() f.Option1:Width(160); f.Option1:ClearAllPoints(); f.Option1:Point("BOTTOM", 0, 45); f.Option2:Width(110); f.Option2:ClearAllPoints(); f.Option2:Point('BOTTOMLEFT', f, 'BOTTOM', 4, 45) end)
		E.Skins:HandleButton(f.Option4, true)

		f.SubTitle = f:CreateFontString(nil, 'OVERLAY')
		f.SubTitle:FontTemplate(nil, 15, nil)
		f.SubTitle:Point("TOP", 0, -40)

		f.Desc1 = f:CreateFontString(nil, 'OVERLAY')
		f.Desc1:FontTemplate()
		f.Desc1:Point("TOPLEFT", 20, -75)
		f.Desc1:Width(f:GetWidth() - 40)

		f.Desc2 = f:CreateFontString(nil, 'OVERLAY')
		f.Desc2:FontTemplate()
		f.Desc2:Point("TOPLEFT", 20, -125)
		f.Desc2:Width(f:GetWidth() - 40)

		f.Desc3 = f:CreateFontString(nil, 'OVERLAY')
		f.Desc3:FontTemplate()
		f.Desc3:Point("TOPLEFT", 20, -175)
		f.Desc3:Width(f:GetWidth() - 40)

		local close = CreateFrame("Button", "InstallCloseButton", f, "UIPanelCloseButton")
		close:Point("TOPRIGHT", f, "TOPRIGHT")
		close:SetScript("OnClick", function()
			f:Hide()
		end)
		E.Skins:HandleCloseButton(close)

		f.tutorialImage = f:CreateTexture('InstallTutorialImage', 'OVERLAY')
		f.tutorialImage:Size(256, 128)
		f.tutorialImage:SetTexture('Interface\\AddOns\\ElvUI_MaUI\\media\\textures\\logo_MaUI.tga')
		f.tutorialImage:Point('BOTTOM', 0, 70)
	end

	MaUIInstallFrame:Show()
	NextPage()
end